﻿package {
	
	import flash.display.*;
	import flash.filters.*;
	import flash.display.Stage;
	import flash.events.*;
	import flash.text.GridFitType;
	
	// Import Papervision3D
	import org.papervision3d.events.*;
	import org.papervision3d.scenes.*;
	import org.papervision3d.cameras.*;
	import org.papervision3d.objects.*;
	import org.papervision3d.materials.*;
	import org.papervision3d.utils.*;
	import org.papervision3d.core.geom.*;
	
	public class Mouse3D_Arrow extends MovieClip {

		public var container :Sprite;
		public var scene     :InteractiveScene3D;
		public var camera    :FreeCamera3D;
		public var ism		 :InteractiveSceneManager;
		public var plane	 :Plane
		public var stak		 :Plane
		public var mouse3D	 :Mouse3D;
		private var vx:Number
		private var vy:Number

		
		public function Mouse3D_Arrow() {
			init();
		}
		
		public function init():void {
			stage.scaleMode = "noScale"
			init3D();
			addEventListener( Event.ENTER_FRAME, loop );
		}
		
		public function init3D():void {
			
			// Create container sprite and center it in the stage
			container = new InteractiveSprite();
			addChild( container );
			container.name = "mainCont";
			container.x = 400;
			container.y = 400;
		
			// Create scene
			scene = new InteractiveScene3D( container );
			ism = scene.interactiveSceneManager;
			mouse3D = ism.mouse3D;
			ism.enableMouse = true;
			
			InteractiveSceneManager.SHOW_DRAWN_FACES = false;
			InteractiveSceneManager.DEFAULT_LINE_COLOR = 0xFFFFFF;
			InteractiveSceneManager.DEFAULT_SPRITE_ALPHA = .75;
			InteractiveSceneManager.DEFAULT_FILL_ALPHA = .75;
			
			ism.buttonMode = true;
			ism.faceLevelMode = true;											
			ism.mouseInteractionMode = false;



			var material:MovieMaterial = new InteractiveMovieMaterial( new Grid());
			material.smooth = true;
		
			
			//Create Ground 
			plane = new Plane(material, 1000, 1000,8)
		

			var material_s:MovieMaterial = new MovieMaterial( new Arrow() );
			material_s.doubleSided = true
			material_s.smooth = true;
			
			
			//Create Mouse stalker 
			stak = new Plane(material_s, 50, 50,4)
			stak.moveBackward(1)
			stak.rotationX = 90
			scene.addChild(plane)
			scene.addChild(stak)
			
			// Create camera
			camera = new FreeCamera3D();
			camera.z = -300;
			camera.x = 100;
			camera.rotationX = 10;

		}
		
		
		
		public function loop(event:Event):void 
		{
			//trace(stak.y)
			//stak.moveUp((ism.mouse3D.y-stak.y)/5)
			//stak.moveRight((ism.mouse3D.x-stak.x)/5)
			var dx:Number = ism.mouse3D.x - stak.x;
			var dy:Number = ism.mouse3D.y - stak.y;
			var degree:Number = Math.atan2(dy, dx) * (180 / Math.PI)
			stak.rotationZ = degree
			stak.y +=((dy)/5)
			stak.x +=((dx)/5)
			scene.renderCamera( this.camera );
		}
		

	}
}